﻿using System;
using System.Windows;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;

namespace CustomAddNewRecord
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        ObservableCollection<Car> source = new ObservableCollection<Car>();

        public Window1()
        {
            InitializeComponent();

            xamDataGrid1.DataSource = source;

            source.Add(new Car(1, "2000", "Audi", "A8", "Metalic", true));
            source.Add(new Car(2, "2002", "BMW", "318i", "White", false));
            source.Add(new Car(3, "2005", "Mercedes", "600", "Black", true));
            source.Add(new Car(4, "2009", "Ford", "Fiesta", "Red", false));
            source.Add(new Car(5, "2001", "BatMobile", "Special Edition", "Black of course", true));



            
            //this.fieldChooser.FieldFilters.Clear();
            //this.xamDataGrid1.FieldLayouts[0].Fields.Clear();
            AddField("Year");
            AddField("Brand");
            AddField("Model");
            AddField("Color");
            AddField("Owner");
            AddField("Condition");
            AddField("Transmission");
            AddField("Doors");
            AddField("Leather");

            AddField("A");
        AddField("B");
        AddField("C");
        AddField("D");
        AddField("E");
        AddField("F");
        AddField("G");
        AddField("H");
        AddField("I");
        AddField("J");
        AddField("K");
        AddField("L");
        AddField("M");
        AddField("N");
        AddField("O");
        AddField("P");
        AddField("Q");
        AddField("R");
        AddField("S");
        AddField("T");
        AddField("U");
        AddField("V");
        AddField("W");
        AddField("X");
        AddField("Y");
        AddField("Z");
        }

        DateTime date = new DateTime(2009, 1, 1);
        public void AddField(string fieldName)
        {
            UnboundField uf = new UnboundField();

            uf.Name = fieldName;
            if (fieldName.Length == 1)
            {
                if (date.Year == 2009)
                {
                    uf.Label = "Actual" + "\r\n" + date.ToString("MMM yyyy");
                }
                else if (date.Year == 2010)
                {
                    uf.Label = "New Budget" + "\r\n" + date.ToString("MMM yyyy") + " - " + date.AddMonths(1).ToString("MMM yyyy");
                }
                date = date.AddMonths(1);
            }
            else
            {
                uf.Label = fieldName;
            }

            PropertyPath p = new PropertyPath(fieldName);
            uf.BindingPath = p;


            FieldSettings fs = new FieldSettings();

            fs.AutoSizeOptions = FieldAutoSizeOptions.All;
            fs.AllowEdit = false;

            fs.AllowSummaries = true;
            fs.SummaryUIType = SummaryUIType.MultiSelect;
            fs.SummaryDisplayArea = SummaryDisplayAreas.Top;
            fs.AllowRecordFiltering = true;

            switch (fieldName)
            {
                case "ID":
                    uf.Visibility = Visibility.Collapsed;
                    fs.AllowHiding = AllowFieldHiding.Never;
                    break;
                case "Year":
                    uf.Visibility = Visibility.Visible;
                    fs.AllowHiding = AllowFieldHiding.Never;
                    break;
                case "Brand":
                    uf.Visibility = Visibility.Collapsed;
                    fs.AllowHiding = AllowFieldHiding.Always;
                    break;
                case "Model":
                    uf.Visibility = Visibility.Collapsed;
                    fs.AllowHiding = AllowFieldHiding.Always;
                    break;
                case "Color":
                    uf.Visibility = Visibility.Visible;
                    fs.AllowHiding = AllowFieldHiding.Never;
                    break;
                case "Owner":
                    uf.Visibility = Visibility.Collapsed;
                    fs.AllowHiding = AllowFieldHiding.Always;
                    break;
                case "Condition":
                    uf.Visibility = Visibility.Collapsed;
                    fs.AllowHiding = AllowFieldHiding.Always;
                    break;
                case "Transmission":
                    uf.Visibility = Visibility.Collapsed;
                    fs.AllowHiding = AllowFieldHiding.Always;
                    break;
                case "Doors":
                    uf.Visibility = Visibility.Collapsed;
                    fs.AllowHiding = AllowFieldHiding.Always;
                    break;
                case "Leather":
                    uf.Visibility = Visibility.Visible;
                    fs.AllowHiding = AllowFieldHiding.Never;
                    break;
                default:
                    if (uf.Label.ToString().Contains("New Budget"))
                    {
                        uf.Visibility = Visibility.Visible;
                        fs.AllowHiding = AllowFieldHiding.Never;
                    }
                    else
                    {
                        uf.Visibility = Visibility.Collapsed;
                        fs.AllowHiding = AllowFieldHiding.Always;
                    }
                    break;
            }


            fs.EditAsType = typeof(String);

            uf.Settings = fs;

            this.xamDataGrid1.FieldLayouts[0].Fields.Add(uf);
        }

        private void xamDataGrid1_Loaded(object sender, RoutedEventArgs e)
        {
            this.xamDataGrid1.ClearCustomizations(CustomizationType.All);

            //Size columns so that full column header is visible
            foreach (var field in this.xamDataGrid1.FieldLayouts[0].Fields)
            {
                field.PerformAutoSize(FieldAutoSizeOptions.Label, FieldAutoSizeScope.RecordsInView);
            }

            PopulateFieldChooserFilters();
        }

        private void PopulateFieldChooserFilters()
        {
            if ((this.fieldChooser.FieldFilters.Count == 0))
            {
                AddFieldFilter("Jan", "January");
                AddFieldFilter("Feb", "February");
                AddFieldFilter("Mar", "March");
                AddFieldFilter("Apr", "April");
                AddFieldFilter("May", "May");
                AddFieldFilter("Jun", "June");
                AddFieldFilter("Jul", "July");
                AddFieldFilter("Aug", "Aug");
                AddFieldFilter("Sep", "Sep");
                AddFieldFilter("Oct", "Oct");
                AddFieldFilter("Nov", "Nov");
                AddFieldFilter("Dec", "Dec");
            }
        }

        private void AddFieldFilter(string label, string description)
        {
            //1. Create a Predicate object to test a condition
            Predicate<Field> fieldFilterCondition =
                new Predicate<Field>(field =>
                {
                    return (field.Label.ToString().Contains(label));
                });

            //2. Create a FieldChooserFilter object that uses the Predicate object
            FieldChooserFilter fieldFilter = new FieldChooserFilter(description, fieldFilterCondition, description);

            //3. Add the FieldChooserFilter object to the FieldChooser control's FieldFilters collection
            this.fieldChooser.FieldFilters.Add(fieldFilter);
        }

    }

    public class Car
    {
        public int ID { get; set; }
        public string Year { get; set; }
        public string Brand { get;  set; }
        public string Model { get;  set; }
        public string Color { get; set; }
        public string Owner { get; set; }
        public string Condition { get; set; }
        public string Transmission { get; set; }
        public string Doors { get; set; }
        public string Leather { get; set; }
        public string A { get; set; }
        public string B { get; set; }
        public string C { get; set; }
        public string D { get; set; }
        public string E { get; set; }
        public string F { get; set; }
        public string G { get; set; }
        public string H { get; set; }
        public string I { get; set; }
        public string J { get; set; }
        public string K { get; set; }
        public string L { get; set; }
        public string M { get; set; }
        public string N { get; set; }
        public string O { get; set; }
        public string P { get; set; }
        public string Q { get; set; }
        public string R { get; set; }
        public string S { get; set; }
        public string T { get; set; }
        public string U { get; set; }
        public string V { get; set; }
        public string W { get; set; }
        public string X { get; set; }
        public string Y { get; set; }
        public string Z { get; set; }

        public bool IsCool { get; set; }
        
        public Car()
        {}
        public Car(int id, string year, string br, string model, string c, bool ic)
        {
            this.ID = id;
            this.Year = year;
            this.Brand = br;
            this.Model = model;
            this.Color = c;
            this.IsCool = ic;

            this.Owner = "Bob";
            this.Condition = "New";
            this.Transmission = "Automatic";
            this.Doors = "4";
            this.Leather = "No";

            this.A = "TEXT";
        this.B = "TEXT";
        this.C = "TEXT";
        this.D = "TEXT";
        this.E = "TEXT";
        this.F = "TEXT";
        this.G = "TEXT";
        this.H = "TEXT";
        this.I = "TEXT";
        this.J = "TEXT";
        this.K = "TEXT";
        this.L = "TEXT";
        this.M = "TEXT";
        this.N = "TEXT";
        this.O = "TEXT";
        this.P = "TEXT";
        this.Q = "TEXT";
        this.R = "TEXT";
        this.S = "TEXT";
        this.T = "TEXT";
        this.U = "TEXT";
        this.V = "TEXT";
        this.W = "TEXT";
        this.X = "TEXT";
        this.Y = "TEXT";
        this.Z = "TEXT";
        }
    }
}
